module Match
where

import PaperRockScissors

-------------------------------------------------------
-- Aus einer Liste von Int-Tupeln wird ein Int-Tupel
-- berechnet. Dabei werden alle Tupelwerte der Liste
-- aufsummiert
-------------------------------------------------------
total :: [(Int, Int)] -> (Int, Int)
total = pair (sum . map fst, sum . map snd)

-------------------------------------------------------
-- Funktion, die aus einem Tupel mit Funktionen und
-- einer Liste ein Ergebnis-Tupel berechnet
-------------------------------------------------------
pair :: ((a -> b), (a -> c)) -> a -> (b,c)
pair (f,g) x = (f x, g x)