module PaperRockScissors
where

data Move 	=  Paper
		  | Rock
		  | Scissors

type Round	= (Move, Move)

-------------------------------------------------------
-- Hier werden die Punkte fr eine Runde vergeben
-------------------------------------------------------
score :: Round -> (Int,Int)
score (x,y)
	| x `beats` y 	= (1,0)
	| y `beats` x 	= (0,1)
	| otherwise	= (0,0)

-------------------------------------------------------
-- Diese Funktion legt fest, wer wen schlaegt
-------------------------------------------------------
beats :: Move -> Move -> Bool
x `beats` y	= or [(m + 1 == n), (m == n + 2)]
		   where
		   m = code x
		   n = code y

-------------------------------------------------------
-- Umrechnung eines Zuges in ein Integerwert
-------------------------------------------------------
code :: Move -> Integer
code Paper 		= 0
code Rock		= 1
code Scissors 	= 2